include get.e

constant dos = {
  128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139,
  140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151,
  152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163,
  164, 165, 168, 169, 170, 171, 172, 173, 174, 175, 181, 182,
  183, 184, 189, 190, 198, 199, 207, 208, 209, 210, 211, 212,
  214, 215, 216, 222, 224, 225, 226, 227, 228, 229, 230, 231,
  232, 233, 234, 235, 236, 237, 238, 239, 241, 243, 244, 245,
  246, 247, 248, 249, 250, 251, 252, 253
  }
constant win = {
  199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239,
  238, 236, 196, 197, 201, 230, 198, 244, 246, 242, 251, 249,
  255, 214, 220, 248, 163, 216, 215, 131, 225, 237, 243, 250,
  241, 209, 191, 174, 172, 189, 188, 161, 171, 187, 193, 194,
  192, 169, 162, 165, 227, 195, 164, 240, 208, 202, 203, 200,
  205, 206, 207, 204, 211, 223, 212, 210, 245, 213, 181, 254,
  222, 218, 219, 217, 253, 221, 175, 180, 177, 190, 182, 167,
  247, 184, 176, 168, 183, 185, 179, 178
  }

sequence cmd
integer source, dest, n
object line

constant DATE = 1
constant TYPE = 2
constant NUMERO = 3
constant TIERS = 4
constant MEMO = 5
constant CATEGORIE = 6
constant THEME = 7
constant MONTANT = 8
constant VF = 9

constant EnregistrementVide = {"", "", "", "", "", "", "", 0, " "}

sequence Ecriture, s

cmd = command_line()
if length(cmd) < 6 then puts(1, "Syntax: QIF2EU Source Dest DefaultType DefaultNum\n") abort(0) end if
source = open(cmd[3], "r")
if source != -1 then
  dest = open(cmd[4], "w")
  Ecriture = EnregistrementVide
  while 1 do
    line = gets(source)
    if atom(line) then exit end if
    for i = 1 to length(win) do
      n = 1
      while n>0 do
	n = find(win[i], line)
	if n > 0 then line[n] = dos[i] end if
      end while
    end for
    if line[1] = 'D' then
      Ecriture[DATE] = line[8..11] & line[5..6] & line[2..3]
    elsif line[1] = 'C' then
      if line[2] = 'X' then
	Ecriture[VF] = "R"
      end if
    elsif line[1] = 'T' then
      n = find(',', line)
      if n > 0 then line = line[1..n-1] & line[n+1..length(line)] end if
      s = value(line[2..length(line)-1])
      if s[1] = GET_SUCCESS then
	Ecriture[MONTANT] = s[2]
      else
	puts(1, "Erreur de conversion")
      end if
    elsif line[1] = 'P' then
      Ecriture[TIERS] = line[2..length(line)-1]
    elsif line[1] = 'N' then
      Ecriture[NUMERO] = line[2..length(line)-1]
    elsif line[1] = 'M' then
      Ecriture[MEMO] = line[2..length(line)-1]
    elsif line[1] = 'L' then
      if line[2] = '[' then
	Ecriture[TYPE] = "Virement"
	Ecriture[CATEGORIE] = line[3..length(line)-2]
      else
	n = find(':', line)
	if n > 0 then
	  Ecriture[CATEGORIE] = line[2..n-1]
	  Ecriture[THEME] = line[n+1..length(line)-1]
	else
	  Ecriture[CATEGORIE] = line[2..length(line)-1]
	end if
      end if
    elsif line[1] = '^' then
      if (compare(Ecriture[NUMERO],"") = 0) or (compare(Ecriture[NUMERO],"VS") = 0) then
	Ecriture[TYPE] = cmd[5]
	Ecriture[NUMERO] = cmd[6]
      end if
      if length(Ecriture[TYPE]) > 8 then Ecriture[TYPE] = Ecriture[TYPE][1..8] end if
      if length(Ecriture[NUMERO]) > 8 then Ecriture[NUMERO] = Ecriture[NUMERO][1..8] end if
      if length(Ecriture[TIERS]) > 30 then Ecriture[TIERS] = Ecriture[TIERS][1..30] end if
      if length(Ecriture[MEMO]) > 30 then Ecriture[MEMO] = Ecriture[MEMO][1..30] end if
      if length(Ecriture[CATEGORIE]) > 15 then Ecriture[CATEGORIE] = Ecriture[CATEGORIE][1..15] end if
      if length(Ecriture[THEME]) > 15 then Ecriture[THEME] = Ecriture[THEME][1..15] end if
      print(dest, Ecriture)
      puts(dest, "\n")
      Ecriture = EnregistrementVide
    end if
  end while
  close(dest)
  close(source)
end if

